--[[ 
This will make powerups spawn at emblem locations.
	*A bit of this code was taken from the StarCoins addon, which is Open Assets.
This will also provide the coding for the powerups.
Big thanks to Lach and Monster Lestyn for helping me get the robot working correctly.
]]--

//Powerup Freeslots and States
freeslot(--Sprites
		 "SPR_PWHM", 
		 "SPR_PWRB", 
		 "SPR_PWRD", 
		 "SPR_PWNP", 
		 "SPR_PWRN",
		 "SPR_NAPM", 
		 "SPR_EXPL",  
		 "SPR_PWBB", 
		 "SPR_TCTL", 
		 "SPR_RBSD", 
		 "SPR_RBWA", 
		 "SPR_RBFL",
		 
		 --Sound Effects
		 "SFX_FINDI",
		 "SFX_EXPLD", 
		 
		 --States
		 "S_HELMETPOWER", 
		 "S_ROBOTPOWER", 
		 "S_ROBOT_TAILS", 
		 "S_RAIDOPOWER", 
		 "S_NAPALMPOWER", 
		 "S_RUNPOWER",
		 "S_NAPALMPRO", 
		 "S_NAP_EXPLODE", 
		 "S_TAILS_ROBOT", 
		 "S_TAILS_ROBOFLY",
		 "S_TAILS_ROBOFLY2",
		 "S_TAILS_ROBOWALK",
		 
		 --Mobjs
		 "MT_HELMET", 
		 "MT_ROBOT", 
		 "MT_ROBOTPRO", 
		 "MT_RAIDO", 
		 "MT_NAPALM", 
		 "MT_RUNSHOE",
		 "MT_NAPALMPRO",
		 "MT_REALROBOT"
)
//Powerups
states[S_HELMETPOWER] = {SPR_PWHM, nil, -1, nil, 0, 0, S_HELMETPOWER}
states[S_ROBOTPOWER] = {SPR_PWRB, nil, -1, nil, 0, 0, S_ROBOTPOWER}
states[S_RAIDOPOWER] = {SPR_PWRD, nil, -1, nil, 0, 0, S_RAIDOPOWER}
states[S_NAPALMPOWER] = {SPR_PWNP, nil, -1, nil, 0, 0, S_NAPALMPOWER}
states[S_RUNPOWER] = {SPR_PWRN, nil, -1, nil, 0, 0, S_RUNPOWER}
states[S_NAPALMPRO] = {SPR_NAPM, FF_ANIMATE|A, -1, A_LobShot, 1, 3, nil}
states[S_NAP_EXPLODE] = {
	sprite = SPR_EXPL,
	frame = FF_ANIMATE|A,
	tics = 42,
	action = A_Explode,
	var1 = 14,
	var2 = 3,
	nextstate = S_NULL
}
//Robot Tails State
states[S_ROBOT_TAILS] = {
	sprite = SPR_TCTL,
	frame = FF_ANIMATE|A,
	tics = 30,
	var1 = 3,
	var2 = 8,
	nextstate = S_ROBOT_TAILS
}
//Robot Mobj State
states[S_TAILS_ROBOT] = {
	sprite = SPR_RBSD,
	tics = 1,
	nextstate = S_TAILS_ROBOT
}
states[S_TAILS_ROBOWALK] = {
	sprite = SPR_RBWA,
	frame = FF_ANIMATE|A,
	tics = 30,
	var1 = 3,
	var2 = 8,
	nextstate = S_TAILS_ROBOWALK
}
states[S_TAILS_ROBOFLY] = {
	sprite = SPR_RBFL,
	frame = FF_ANIMATE|A,
	tics = 23,
	var1 = 7,
	var2 = 3,
	nextstate = S_TAILS_ROBOFLY2
}
states[S_TAILS_ROBOFLY2] = {
	sprite = SPR_RBFL,
	frame = FF_ANIMATE|J,
	tics = 6,
	var1 = 1,
	var2 = 3,
	nextstate = S_TAILS_ROBOFLY2
}

//Powerup Objects
mobjinfo[MT_HELMET] = {
	doomednum = -1,
	spawnstate = S_HELMETPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_ROBOT] = {
	doomednum = -1,
	spawnstate = S_ROBOTPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_RAIDO] = {
	doomednum = -1,
	spawnstate = S_RAIDOPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_NAPALM] = {
	doomednum = -1,
	spawnstate = S_NAPALMPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_RUNSHOE] = {
	doomednum = -1,
	spawnstate = S_RUNPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_NAPALMPRO] = {
	spawnstate = S_NAPALMPRO,
	spawnhealth = 1,
	height = 40*FRACUNIT,
	radius = 18*FRACUNIT,
	speed = 25*FRACUNIT,
	seesound = sfx_s3k51,
	deathstate = S_NAP_EXPLODE,
	damage = 500*FRACUNIT,
	deathsound = sfx_expld,
	flags = MF_MISSILE
}
mobjinfo[MT_ROBOTPRO] = {
	spawnstate = S_ROBOT_TAILS,
	spawnhealth = 100,
	height = 40*FRACUNIT,
	radius = 18*FRACUNIT,
	speed = 10*FRACUNIT,
	seesound = sfx_cdfm47,
	deathstate = S_NULL,
	damage = 5*FRACUNIT,
}
	
//Powerup RNG Table
//Huge shoutout to Amperbee for the help on getting me to understand how the fuck this all works
local powerups = {
	MT_RAIDO,
	MT_NAPALM,
	MT_RUNSHOE,
	MT_ROBOT,
	MT_HELMET
}

local collected_emblems = {}

local function should_marathon_reset()
    return marathonmode & MA_INGAME != 0 and gamemap == spmarathon_start and consoleplayer.starpostnum <= 0
end

//If TATails Exists, Replace Emblems
addHook("MapLoad", function()
	if should_marathon_reset() then
		if consoleplayer and consoleplayer.mo and consoleplayer.mo.skin == "tatails"
			consoleplayer.tailsrun = false
			consoleplayer.tailshelmet = false
			consoleplayer.tailsnapalm = false
			consoleplayer.tailsrobot = false
			consoleplayer.tailsraido = false
			consoleplayer.tailsselect = 1
			collected_emblems = {} -- clear powerup cache
		end
	end
	for mapt in mapthings.iterate do
		if mapt.type == mobjinfo[MT_EMBLEM].doomednum then
			if collected_emblems[mapt.angle + 1] then
				continue
			end
			local x = mapt.x*FRACUNIT
			local y = mapt.y*FRACUNIT
			local floor = R_PointInSubsector(x, y).sector.floorheight -- Base Floor Height for Z check.
			local slope = R_PointInSubsectorOrNil(x,y).sector.f_slope    -- Check for slope

			if slope != nil    -- If ring is on a slope
				floor = P_GetZAt(slope,x,y) -- Use slope position as floor height instead
            end
			
            local z = floor + 32*FRACUNIT + mapt.z*FRACUNIT
			local randomPower = P_RandomRange(1, #powerups)
			local randomPowerValue = powerups[randomPower]
			local power = P_SpawnMobj(x, y, z, randomPowerValue)
			power.angle = mapt.angle
		end
	end
end)

-- reset collected power cache
addHook("MapChange", function(m)
	if m ~= gamemap then
		collected_emblems = {}
	end
end)

-- reset collected power cache when exiting to title/desktop
addHook("GameQuit", function(quitting)
	collected_emblems = {}
end)

-- Part 2
addHook("MobjThinker", function(s)
	if s.valid
		s.flags = $|MF2_DONTDRAW
	end
end, MT_EMBLEM)

local IsValid = function(mo)
	return (mo and mo.valid)
end

//Run Power Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsrun = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_RUNSHOE)

//Shoes Make Tails Faster
//Code by Lach, the G.O.A.T
local MODE_DEFAULT = 0
local MODE_TAILSRUN = 1
local MODE_2PBOT = 2
local MODE_TAILSSUPERRUN = 3

local tailsstats = {
    [MODE_DEFAULT] = {
        normalspeed = 32*FRACUNIT,
        acceleration = 50,
        accelstart = 192,
        thrustfactor = 3
    },
    [MODE_TAILSRUN] = {
        normalspeed = 39*FRACUNIT,
        acceleration = 40,
        accelstart = 96,
        thrustfactor = 5
    },
    [MODE_2PBOT] = {
        normalspeed = 36*FRACUNIT,
        acceleration = 32,
        accelstart = 76,
        thrustfactor = 6
    },
	[MODE_TAILSSUPERRUN] = {
        normalspeed = 36*FRACUNIT,
        acceleration = 40,
        accelstart = 96,
        thrustfactor = 5
    }
}

local function GetTailsMode(player)
    if (player.tailsrun
	and player.tailsselect == 4)
		return MODE_TAILSRUN
	end
	if (player.tailsrun
	and player.tailsselect == 4
	and player.powers[pw_super])
		return MODE_TAILSSUPERRUN
	end
    if player.bot == BOT_2PAI
        return MODE_2PBOT
    end
	return MODE_DEFAULT
end

addHook("PlayerThink", function(player)
    if not player.mo
    or player.mo.skin ~= "tatails"
    or player.exiting
    or player.powers[pw_carry] == CR_NIGHTSMODE
        return
    end
    local mode = GetTailsMode(player)
    if mode ~= player.tailsmode
        local stats = tailsstats[mode]
		if not player.xmomtoggledoff
			player.tailsmode = mode
			player.fakenormalspeed = stats.normalspeed
			player.acceleration = stats.acceleration
			player.accelstart = stats.accelstart
			player.thrustfactor = stats.thrustfactor
		end
		player.tailsmode = mode
		player.normalspeed = stats.normalspeed
		player.acceleration = stats.acceleration
		player.accelstart = stats.accelstart
		player.thrustfactor = stats.thrustfactor
    end
end)

//Helmet Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailshelmet = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_HELMET)

local monitor = nil
local autoaim = nil

//Napalm Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsnapalm = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_NAPALM)

//Napalm Thinkers
addHook("ThinkFrame", function() -- Code from Dummy Ring Bomb, which is Open Assets
	for player in players.iterate do
		if player.mo.skin ~= "tatails" then
			continue
		end
		if not (player.exiting) // If the player isn't exiting the level...
			if not (P_PlayerInPain(player) or (player.playerstate == PST_DEAD)) // Then, if the player isn't in pain or dead...
				if ((player.powers[pw_carry] == CR_NONE) and not (player.pflags == PF_SPINNING)) // Then if the player isn't being carried or spinning...
					if not (player.cmd.buttons & BT_CUSTOM3) // Then if Custom 3 isn't pressed...
						player.cust3tapready = true -- The following makes it act as a singular button press
						player.cust3tapping = false
					elseif player.cust1tapready
						player.cust3tapping = true
						player.cust3tapready = false
					else
						player.cust3tapping = false
					end
					-- Conditions in which you're ready to shoot
					if player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.pflags & PF_JUMPED or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT or player.mo.state == S_PLAY_FLY
						if player.cust3tapping and not player.bombcooldown // If the above function is true while the cooldown isn't active...
							if autoaim and autoaim.valid and player.mo.state != S_PLAY_FLY
								monitor = P_SpawnMissile(player.mo, autoaim, MT_NAPLAMPRO)
								if (player.mo.momz > 0 and not player.powers[pw_tailsfly]) // If you're moving vertically, but not flying...
									monitor.momz = (player.mo.momz)+(7*FRACUNIT) -- Launches the monitor based on your vertical momentum
								else // Otherwise...
									if (player.powers[pw_tailsfly]) // If the player is flying...
										monitor.momz = 0*FRACUNIT -- The monitor will be dropped
									else
										monitor.momz = 7*FRACUNIT -- The monitor will be launched upwards
									end
								end
								if (player.mo.eflags & MFE_VERTICALFLIP) // If the player is upside down...
									if (player.powers[pw_tailsfly])
										monitor.momz = 0*FRACUNIT
									else
										monitor.momz = -7*FRACUNIT -- Launches it in the opposite direction
									end
								end
								if not (player.powers[pw_tailsfly]) // If the player isn't flying...
									P_InstaThrust(monitor, player.mo.angle, ((player.speed)+(7*FRACUNIT))) -- Throws the monitor based on your angle and speed
								end
							end
						end
					end
				end
			end
		end
	end
end)

--Part 2
addHook("MobjThinker", function(flamen)
	-- Defines the player
	for player in players.iterate do
		local p = player.mo
		-- Gravity Flip
		if (p.eflags & MFE_VERTICALFLIP)
			flamen.eflags = $1|MFE_VERTICALFLIP -- Considers it flipped
			flamen.flags2 = $1|MF2_OBJECTFLIP -- Visually flips it upside down
		end
		-- Floor breaking
		if P_IsObjectOnGround(flamen) // If the napalm is on the ground...
			for x = flamen.x, flamen.x + flamen.radius, flamen.radius -- The following will set up variables for floor breaking
				for y = flamen.y, flamen.y + flamen.radius, flamen.radius
					local ss = R_PointInSubsector(x,y)
					for fof in ss.sector.ffloors()
						if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS) // If a breakable floor exists where the napalm lands...
							EV_CrumbleChain(ss.sector, fof) -- Breaks that floor
						end
					end
				end
			end
		end
	end
end, MT_NAPALMPRO)

--Part 3
addHook("MobjThinker", function(mobj)
	if not (mobj.flags & MF_MISSILE)
		local maxdist = 194*mobj.scale
		searchBlockmap("objects",function(refmobj,mo)
			if mo and mo.valid and mo.health
			and (mo.type == MT_SPIKE 
			or mo.type == MT_WALLSPIKE
			or mo.type == MT_SALOONDOORCENTER
			or (mo.type ~= MT_PLAYER and mo.flags & MF_SHOOTABLE !=0))
				if (mo.flags & MF_BOSS)
					return
				end
				P_KillMobj(mo, mobj, mobj.target)
			end
		end, mobj,mobj.x-maxdist,mobj.x+maxdist,mobj.y-maxdist,mobj.y+maxdist)
	end
end, MT_NAPALMPRO)

//Make The Nuke Do Double Damage
addHook("MobjDamage", function(mobj, inf, src, dmg, dmgtype)
	if not inf
		return
	end
	
	if inf.type == MT_NAPALMPRO and mobj.health > 1 and dmg <= 1
		P_DamageMobj(mobj, inf, src, dmg*2, dmgtype)
		return true
	end
end)

//What Is A Wall????
local wallbreak = function(mobj, sectorthing)
	for fof in sectorthing.ffloors()
		if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
			local foffloor = fof.topheight
			local fofceiling = fof.bottomheight
			if fof.b_slope and fof.b_slope.valid
				fofceiling = P_GetZAt(fof.b_slope, mobj.x, mobj.y)
			end
			if fof.t_slope and fof.t_slope.valid
				foffloor = P_GetZAt(fof.t_slope, mobj.x, mobj.y)
			end
			if foffloor >= mobj.z and fofceiling <= mobj.z+mobj.height
				EV_CrumbleChain(nil, fof)
				if fof.master.flags & ML_EFFECT5
					P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mobj, sectorthing)
				end
				return true
			end
		end
	end
end

//Break The Walls, Napalm Edition
addHook("MobjLineCollide", function(mobj, line)
	local mlemn -- Because :3
	local mlemn2 -- Because I'm so :3
	
	if not (line and line.valid and mobj and mobj.valid)
		return
	end
	
	if line.frontsector
	and line.frontsector.valid
		mlemn = wallbreak(mobj,line.frontsector)
	end
	
	if line.backsector
	and line.backsector.valid
		mlemn2 = wallbreak(mobj, line.backsector)
	end
	
	if mlemn
	or mlemn2
		P_ExplodeMissile(mobj)
	end
end, MT_NAPALMPRO)

//Robot Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsrobot = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_ROBOT)

-- Replace The Player Sprite With Robot's
addHook("PlayerThink", function(p)
	for p in players.iterate
		local mo = p.mo
		local skin = "tatails"
	
		if not (mo or mo.valid
		or mo.skin ~= skin)
			continue
		end
		
		-- Cheat the system. Instead of controling the robot, spawn a fake Tails and create an overlay.
		if p.cmd.buttons & BT_TOSSFLAG
		and p.tailsrobot
		and p.tailsselect == 5
		and not p.tailsroboting
		and not p.exiting
		and not G_IsSpecialStage()
			p.robot = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_ROBOTPRO) -- Fake Tails Mobj
			-- Fake Tails uses the player's skincolor
			p.robot.color = p.skincolor
			p.robot.shadowscale = 9*FRACUNIT/10
			-- Make the robot spawn in front of us
			P_TryMove(mo, 
			mo.x + P_ReturnThrustX(nil, mo.angle, 50*FRACUNIT),
			mo.y + P_ReturnThrustY(nil, mo.angle, 50*FRACUNIT), true)
			p.realrobot = P_SpawnMobj(mo.x, mo.y, mo.z, MT_OVERLAY) -- Real Robot Mobj
			-- The robot will follow the invisible player
			p.realrobot.target = mo
			p.realrobot.state = S_TAILS_ROBOT
			-- Robot uses the player's skin color
			p.realrobot.color = p.skincolor
			p.realrobot.shadowscale = 9*FRACUNIT/10
			p.tailsroboting = true
		end
	
		if p.tailsroboting
			p.normalspeed = 14*FRACUNIT
			p.height = 32*FRACUNIT
			p.mo.flags2 = $|MF2_DONTDRAW
			
			if (mo.state == S_PLAY_STND
			or mo.state == S_PLAY_JUMP
			or mo.state == S_PLAY_SPRING
			or mo.state == S_PLAY_EDGE)
			and p.realrobot.state ~= S_TAILS_ROBOT
				p.realrobot.state = S_TAILS_ROBOT
			end
			-- Robot Walking Frames
			if (mo.state == S_PLAY_FALL
			or mo.state == S_PLAY_WALK
			or P_PlayerInPain(p))
			and p.realrobot.state ~= S_TAILS_ROBOWALK
				p.realrobot.state = S_TAILS_ROBOWALK
			end
			-- Robot Flying Frames
			if (mo.state == S_PLAY_FLY
			or mo.state == S_PLAY_FLY_TIRED
			or mo.state == S_PLAY_SWIM)
			and p.realrobot.state ~= S_TAILS_ROBOFLY
				if p.realrobot.state == S_TAILS_ROBOFLY2
					continue
				end
				p.realrobot.state = S_TAILS_ROBOFLY
			end
			-- Part 2
			if (mo.state == S_PLAY_FLY
			or mo.state == S_PLAY_FLY_TIRED
			or mo.state == S_PLAY_SWIM)
			and p.realrobot.state ~= S_TAILS_ROBOFLY2
				if p.realrobot.state == S_TAILS_ROBOFLY
					continue
				end
				p.realrobot.state = S_TAILS_ROBOFLY2
			end
			if (p.cmd.buttons & BT_USE
			or p.exiting
			or mo.state == S_PLAY_DEAD
			or mo.state == S_PLAY_DRWN
			and not (mo.state == S_PLAY_FLY
			or mo.state == S_PLAY_FLY_TIRED
			or (mo.state == S_PLAY_SWIM and mo.eflags & MFE_UNDERWATER)))
			or not (mo.health or mo.valid)
				P_SetOrigin(mo, p.robot.x, p.robot.y, p.robot.z)
				p.normalspeed = 32*FRACUNIT
				p.height = 48*FRACUNIT
				P_RemoveMobj(p.robot)
				P_RemoveMobj(p.realrobot)
				mo.state = S_PLAY_STND
				p.tailsroboting = false
			end
		end
	end
end)

addHook("PlayerSpawn", function(player)
	if not (player.mo or player.mo.valid
	or player.mo.skin ~= "tatails")
		return
	end
	player.tailsroboting = false
end)

-- I couldn't make the robot explode so instead it will shoot corks because I'm not smart T-T
-- Code from OpenCharacterAssets
local skin = "tatails" // your character here
local thebutton = BT_CUSTOM3 // the button needed to fire the projectile
local sound = sfx_cdfm70 // the shooting sound
local projectile = MT_CORK // the projectile itself
local autoaim = true // if this is true, the projectile is automatically aimed
local hasdelay = true // if this is true, you will have a delay while firing
local firedelay = 4 // the delay of firing if hasdelay is true

local theproj = MT_NULL

addHook("PlayerThink", function(player)
	if not player.tailsroboting
		return
	end
	if player.mo.shootaim == nil
		player.mo.shootaim = 0
	end
	if player.mo.projangle == nil
		player.mo.projangle = 0
	end
	if player.mo.buttonholding == nil
		player.mo.buttonholding = false
	end
	if not (player.cmd.buttons & thebutton) 
		player.mo.buttonholding = false
	end
	if player.mo and player.mo.skin == skin
	and autoaim == true
	and player.weapondelay == 0
		player.mo.shootaim = P_LookForEnemies(player, false, true)
		if player.mo.shootaim and player.mo.shootaim.valid and player.mo.shootaim.health
			player.mo.projangle = R_PointToAngle2(player.mo.x, player.mo.y, player.mo.shootaim.x, player.mo.shootaim.y)
			P_SpawnLockOn(player, player.mo.shootaim, S_LOCKON1)
		end
	end
	if player.mo and player.mo.skin == skin
	and (player.cmd.buttons & thebutton)
	and hasdelay == true
	and not player.weapondelay
		if player.mo.shootaim and player.mo.shootaim.valid and autoaim == true
			theproj = P_SpawnMissile(player.mo, player.mo.shootaim, projectile)
		else
			theproj = P_SpawnPlayerMissile(player.mo,projectile)
		end
		S_StartSound(player.mo, sound)
		player.weapondelay = TICRATE*firedelay
		if hasrecoil == true
			P_InstaThrust(player.mo, player.mo.angle, -FRACUNIT*recoil)
		end
	end
	if player.mo and player.mo.skin == skin
	and (player.cmd.buttons & thebutton)
	and hasdelay == false
	and not player.mo.buttonholding
		player.mo.buttonholding = true
		if player.mo.shootaim and player.mo.shootaim.valid and autoaim == true
			P_SpawnMissile(player.mo, player.mo.shootaim, projectile)
		else
			P_SPMAngle(player.mo,projectile,player.mo.angle,0)
		end
		S_StartSound(player.mo, sound)
		if hasrecoil == true
			P_InstaThrust(player.mo, player.mo.angle, -FRACUNIT*recoil)
		end
	end
end)

//Raido Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		/*if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			s.player.mo.state = S_TAILS_PICKUP
		end*/
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsraido = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_RAIDO)

//Raido Music Table
local raidomusic = {
	"TABF",
	"TABB",
	"TACF",
	"TACI",
	"TACR",
	"TALC",
	"TALR",
	"TAMP",
	"TAPM",
	"TAPF",
	"TATH",
	"TAVT"
}

local raidotracks = {
	"Battle Fortress",
	"Boss Battle!",
	"Canon Forest",
	"Coco Island",
	"Credits",
	"Lake Crystal",
	"Lake Rocky",
	"Map",
	"Poly Mountain",
	"Poloy Forest",
	"Tails' House",
	"Volcanic Tunnel"
}

//Raido Thinker
addHook("PlayerThink", function(player)
	local mo = player.mo
	local skin = "tatails"
	
	if not (mo or mo.valid)
	or mo.skin ~= skin
		return
	end

	if player.raidosong == nil
		player.raidosong = 1
	end
	
	if not (player.cmd.buttons & BT_WEAPONNEXT)
		player.nexttap = false
		player.nextready = true
	elseif player.nextready
		player.nexttap = true
		player.nextready = false
	else
		player.nexttap = false
	end
	
	if not (player.cmd.buttons & BT_WEAPONPREV)
		player.prevtap = false
		player.prevready = true
	elseif player.prevready
		player.prevtap = true
		player.prevready = false
	else
		player.prevtap = false
	end

	if player.tailsraido
	and player.tailsselect == 6
		if player.nexttap
			if player.raidosong == #raidotracks
				return
			end
			player.raidosong = $ + 1
			S_StartSound(nil, sfx_menu1, player)
		end
		if player.prevtap
			if player.raidosong == 1
				return
			end
			player.raidosong = $ - 1
			S_StartSound(nil, sfx_menu1, player)
		end
		if player.cmd.buttons & BT_TOSSFLAG
			S_ChangeMusic(raidomusic[player.raidosong], true, player)
			player.tailsraidoing = true
		end
		if player.tailsraidoing
			if player.cmd.buttons & BT_ATTACK
				P_RestoreMusic(player)
			end
		end
	end
end)

//Raido HUD
hud.add(function(v, player)
	local fpp = V_PERPLAYER
	if player.tailsraido
	and player.tailsselect == 6
		v.drawString(15, 95, "Song List:", fpp, "thin-center")
		local prev_track = player.raidosong - 1
		local next_track = player.raidosong + 1
		if prev_track > 0 then
			v.drawString(15, 130, raidotracks[prev_track], fpp, "small-center")
		end
		v.drawString(15, 120, raidotracks[player.raidosong], fpp|V_YELLOWMAP, "small-center")
		if next_track <= #raidotracks then
			v.drawString(15, 110, raidotracks[next_track], fpp, "small-center")
		end
	end
end)
